<?php

namespace App\Components;

use App\Model\Subscriber;
use SQLite3;
use SQLite3Exception;
use Exception;

class UserStorage extends Storage
{

    public function __construct($filename)
    {
	parent::__construct($filename);
    }


    public function get_users()
    {
	$this->setQuery('SELECT * from subscriber');
	$result = $this->query();
	$users = [];
	foreach($result as $u)
	{
	    $user = Subscriber::from_array($u);
	    $users[] = $user;
	}
	return $users;
    }

    public function get_user($id)
    {
	$this->setQuery("SELECT * from subscriber where id=:id");
	$this->bindValues([[':id', $id, SQLITE3_INTEGER]]);
	$result = $this->query();
	$users = [];
	foreach($result as $u)
	{
	    $user = Subscriber::from_array($u);
	    $users[] = $user;
	}
	return $user;
    }


    public function search_by_number($number)
    {
	$this->setQuery("SELECT * from subscriber where username=:number");
	$This->bindValues([[':number', $number, SQLITE3_TEXT]]);
	$result = $this->query();
	$users = [];
	foreach($result as $u)
	{
	    $user = Subscriber::from_array($u);
	    $users[] = $user;
	}
	return $users;
    }

    public function delete_user($id)
    {
	$this->setQuery("DELETE from subscriber where id=:id");
	$this->bindValues([[':id', $id, SQLITE3_INTEGER]]);
	$result = $this->query();
	return $result;
    }

    public function insert_user($u){
	$temp = "INSERT INTO subscriber (username, domain, password)";
	$temp .= "VALUES(:number, :domain, :pass)";
	$this->setQuery($temp);
	$this->bindValues([[':number', $u->number, SQLITE3_TEXT],
			   [':domain', $u->domain, SQLITE3_TEXT],
			   [':pass', $u->pass, SQLITE3_TEXT]]);
	$result = $this->query();
	return $result;
    }

    public function update_user($u){
	$temp = "UPDATE subscriber SET ";
	$temp .= "username=:number, ";
	$temp .= "domain=:domain, ";
	$temp .= "password=:pass ";
	$temp .= "WHERE	id = :id;";
	$this->setQuery($temp);
	$this->bindValues([[':id', $u->id, SQLITE3_INTEGER],
			   [':number', $u->number, SQLITE3_TEXT],
			   [':domain', $u->domain, SQLITE3_TEXT],
			   [':pass', $u->pass, SQLITE3_TEXT]]);
	$result = $this->query();
	return $result;
    }

}
