<?php

namespace App\Model;

class Dialplan
{
    public int $id;
    public int $dpid;
    public int $pr;
    public int $match_op;
    public string $match_exp;
    public int $match_len;
    public string $subst_exp;
    public string $repl_exp;
    public string $attrs;

    public function __construct()
    {
	$this->id = 0;
	$this->dpid = 1;
	$this->pr = 100;
	$this->match_op = 1;
	$this->match_exp = "";
	$this->match_len = 0;
	$this->subst_exp = "";
	$this->repl_exp = "";	
	$this->attrs = "";
    }


    public static function from_array(array $dialplan): Dialplan
    {
	$d = new Dialplan();
	if(isset($dialplan['id'])){
	    $d->id = $dialplan['id'];
	};
	
	if(isset($dialplan['dpid'])){
	    $d->class = $dialplan['dpid'];
	};

	if(isset($dialplan['pr'])){
	    $d->pr = $dialplan['pr'];
	};

	if(isset($dialplan['match_op'])){
	    $d->match_op = $dialplan['match_op'];
	};

	if(isset($dialplan['match_exp'])){
	    $d->match_exp = $dialplan['match_exp'];
	};

	if(isset($dialplan['match_len'])){
	    $d->match_len = $dialplan['match_len'];
	};
	
	if(isset($dialplan['subst_exp'])){
	    $d->subst_exp = $dialplan['subst_exp'];
	};

	if(isset($dialplan['repl_exp'])){
	    $d->repl_exp = $dialplan['repl_exp'];
	};

	if(isset($dialplan['attrs'])){
	    $d->attrs = $dialplan['attrs'];
	};
	return $d;
    }

    public function storage($storage)
    {
	$this->storage = $storage;
    }
    

    public static function all($storage): array
    {
	return $storage->get_dialplans();
    }

    public function read(): Dialplan
    {
	return $this->storage->get_dialplan($this->id);
    }

    public function find(): array
    {
	return $this->storage->search_by_class($this->id);
    }

    public function save()
    {
	/* echo var_dump($this); */
	if($this->id === 0){
	    echo "insert new dialplan";
	    $this->storage->insert_dialplan($this);
	} else {
	    echo "update dialplan";
	    $this->storage->update_dialplan($this);
	}
    }

    public function remove(): bool
    {
	try
	{
	    $result =  $this->storage->delete_dialplan($this->id);
	    return true;
	}
	catch(Exception $e){
	    throw $e;
	}	
    }
    
}
