<?php

namespace App\Model;

use Exception;


class  Subscriber
{
    public int $id;
    public string $number;
    public string $domain;
    public string $pass;

    private $storage;
    
    public function __construct()
    {

    }

    public static function from_array(array $subscriber): Subscriber
    {
	$u = new Subscriber();
	if(isset($subscriber['id'])){
	    $u->id = $subscriber['id'];
	} else {
	    $u->id = 0;
	};
	if(isset($subscriber['username'])){
	    $u->number = $subscriber['username'];
	};
	if(isset($subscriber['domain'])){
	    $u->domain = $subscriber['domain'];
	};
	if(isset($subscriber['password'])){
	    $u->pass = $subscriber['password'];
	}
	return $u;
    }

    public function storage($storage)
    {
	$this->storage = $storage;
    }
    
    public function get_number(): string
    {
	return $this->number;
    }

    public function get_domain(): string
    {
	return $this->domain;
    }

    public static function all($storage): array
    {
	return $storage->get_users();
    }

    public function read(): Subscriber
    {
	return $this->storage->get_user($this->id);
    }

    public function find(): array
    {
	return $this->storage->search_by_number($this->number);
    }

    public function save()
    {
	/* echo var_dump($this); */
	if($this->id === 0){
	    echo "insert new user";
	    $this->storage->insert_user($this);
	} else {
	    echo "update user";
	    $this->storage->update_user($this);
	}
    }

    public function remove(): bool
    {
	try
	{
	    $result =  $this->storage->delete_user($this->id);
	    return true;
	}
	catch(Exception $e){
	    throw $e;
	}	
    }

}


