<?php

namespace App\Modules;

use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Slim\Views\Twig;

class BaseHandler
{
    protected $view;
    protected $request;
    protected $response;
    protected $message;
    protected $user;
    
    public function __construct()
    {
	$this->user = $_SESSION;
    }

    protected function prepare(ServerRequestInterface $request, ResponseInterface $response)
    {
	$this->request = $request;
	$this->view = Twig::fromRequest($request);
	$this->response = $response;
    }
    
    protected function render(string $page, array $data): ResponseInterface
    {
	return $this->view->render($this->response, $page,
				   ['data' => $data,
				    'message' => $this->message,
				    'user' => $this->user]);
    }

    protected function redirect(string $location): ResponseInterface
    {
	return $this->response->withStatus(302)
		    ->withHeader('Location', $location);
    }
}
