<?php

namespace App\Modules;

use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Psr\Container\ContainerInterface;
use Psr\Http\Message\UploadedFileInterface;
use App\View\Page;

class Update
{
    private $tpm_folder;
    
    public function __construct(ContainerInterface $container)
    {
	$this->tmp_folder = "/tmp";
    }

    public function show(ServerRequestInterface $request,
			 ResponseInterface $response, array $args): ResponseInterface
    {
	$view = Page::fromRequest($request);
	$rauc_status = shell_exec('rauc status --detailed --output-format=json');
	$status = json_decode($rauc_status, true);
	$params = $request->getQueryParams();
	$update = [];
	if (isset($params['filename'])){
	    $filename = $params['filename'];
	    $update = json_decode(shell_exec("rauc --output-format=json info $filename"),
				  true);
	}
	$update_files = glob("/tmp/*.rauc");
	return $view->render($response, 'update.html', [
	    'status' => $status,
	    'update_files' => $update_files,
	    'update' => $update,
	    'filename' => $filename
	]);
    }

    public function load_image(ServerRequestInterface $request,
			       ResponseInterface $response,
			       array $args): ResponseInterface
    {
	$view = Page::fromRequest($request);
	$directory = $this->tmp_folder;
	$uploadedFiles = $request->getUploadedFiles();
	/* echo var_dump($uploadedFiles); */
	// handle single input with single file upload
	$uploadedFile = $uploadedFiles['update'];
	$error = $uploadedFile->getError();
	if ($error == UPLOAD_ERR_OK) {
	    echo "upload file OK";
	    $filename = $this->moveUploadedFile($uploadedFile);
	    echo $filename;
	    /* $response->getBody()->write('Uploaded: ' . $filename . '<br/>'); */
	} else {
	    echo "upload file ERROR";
	    echo var_dump($error);
	}
	$status = shell_exec('rauc status --detailed --output-format=json');
	$update = json_decode(
	    shell_exec("rauc --output-format=json info $directory/$filename"),
	    true);
	return $response->withStatus(302)
			->withHeader('Location', "/ui/update");
    }

    private function moveUploadedFile(UploadedFileInterface $uploadedFile)
    {
	$filename = $uploadedFile->getClientFilename();
	$uploadedFile->moveTo($this->tmp_folder . DIRECTORY_SEPARATOR . $filename);
	return $filename;
    }

    public function update_image(ServerRequestInterface $request,
				 ResponseInterface $response,
				 array $args): ResponseInterface
    {
	$params = $request->getParsedBody();
	$view = Page::fromRequest($request);
	if (isset($params['file'])){
	    $resp = shell_exec("sudo /var/www/cgi/update_release 2>&1 ".$params['file']);
	    $status = shell_exec('rauc status --detailed --output-format=json');
	    $status = json_decode($status, true);
	    return $view->render($response, 'update_complete.html', [
		'resp' => $resp,
		'status' => $status
	    ]);
	} else {
	    return $response->withStatus(302)
			    ->withHeader('Location', "/ui/update");
	}
    }
}

