<?php

namespace App\Modules;

use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Psr\Container\ContainerInterface;
use App\Model\Subscriber;
use App\Components\UserStorage;

class User extends BaseHandler
{
    
    public function __construct(ContainerInterface $container)
    {
	parent::__construct();
    }
    public function all_user(ServerRequestInterface $request,
			     ResponseInterface $response, array $args): ResponseInterface
    {
	$storage = new UserStorage("private/dbtext");
	$this->prepare($request, $response);
	$users = Subscriber::all($storage);
	return $this->render('users.html',
			     [ 'users' => $users]);
    }

    public function new_user(ServerRequestInterface $request,
			     ResponseInterface $response, array $args): ResponseInterface
    {
	$this->prepare($request, $response);
	$user = new Subscriber();
	return $this->render('edit_user.html',
			     [ 'user' => $user]);
    }

    public function edit_user(ServerRequestInterface $request,
			      ResponseInterface $response, array $args): ResponseInterface
    {
	$storage = new UserStorage("private/dbtext");
	$this->prepare($request, $response);
	$userid = $args['userid'];
	$user = new Subscriber();
	$user->id = $userid;
	$user->storage($storage);
	$u = $user->read();
	return $this->render('edit_user.html',
			     [ 'user' => $u]);
    }

    public function create_user(ServerRequestInterface $request,
				ResponseInterface $response,
				array $args): ResponseInterface
    {
	$storage = new UserStorage("private/dbtext");
	$this->prepare($request, $response);
	$userid = "new";
	$data = $request->getParsedBody();
	$user = Subscriber::from_array($data);
	$user->storage($storage);
	if(isset($data['save']))
	{
	    $user->save();
	}
	return $this->redirect("/ui/user");
    }

    public function update_user(ServerRequestInterface $request,
				ResponseInterface $response,
				array $args): ResponseInterface
    {
	$storage = new UserStorage("private/dbtext");
	$this->prepare($request, $response);
	$userid = $args['userid'];
	$data = $request->getParsedBody();
	$data['id'] = $userid;
	$user = Subscriber::from_array($data);
	echo var_dump($data);
	$user->storage($storage);
	if(isset($data['save']))
	{
	    $user->save();
	}
	return $this->redirect("/ui/user");
    }

    public function delete_user(ServerRequestInterface $request,
				ResponseInterface $response,
				array $args): ResponseInterface
    {
	$storage = new UserStorage("private/dbtext");
	$this->prepare($request, $response);
	$userid = $args['userid'];
	$user = new Subscriber();
	$user->id = $userid;
	$user->storage($storage);
	$user->remove();
	return $this->redirect("/ui/user");
    }
}
