<?php declare(strict_types=1);

use PHPUnit\Framework\TestCase;
use App\Model\Subscriber;
use App\Components\Storage;


/* require_once  '../vendor/autoload.php'; */

final class SubscriberTest extends TestCase
{
    public function testCanCreateSubscriber(): void
    {
	
	$this->expectException(Exception::class);

	$storage = new Storage("private/dbtext");
	
        $number = "12";

        $domain = 'telecom.mvtel.local';

	$user = Subscriber::from_array(['username' => "12",
					'domain' => "telecom.mvtel.local",
					'password' => "12"]);

	$user1 = Subscriber::from_array(['username' => "15",
					 'domain' => "telecom.mvtel.local",
					 'password' => "15"]);

	/* echo var_dump($user1); */
	/* $user1->save(); */
	
        $this->assertSame($user->get_number(), "12");
	$this->assertSame($user->get_domain(), $domain);

	/* $user->number = "111";
	   $user->save(); */
	
    }

    public function testCanReadSubscriber(): void
    {

	$storage = new Storage("private/dbtext");
	
	$users = Subscriber::all($storage);

	
	$user2 = new Subscriber();
	$user2->id = $users[0]->id;
	$user2->storage($storage);

	$user3 = $user2->read();
	$this->assertSame($users[0]->number, $user3->number);

    }

    public function testnFindSubscriber(): void
    {

	$storage = new Storage("private/dbtext");
	$user = Subscriber::from_array(['username' => "13"]);
	$user->storage($storage);
	$user1 = $user->find()[0];
	/* echo var_dump($user); */
	$this->assertSame($user1->pass, "13");

    }

    public function testnInsertDeleteSubscriber(): void
    {
	$storage = new Storage("private/dbtext");
	$user = Subscriber::from_array(['username' => "155",
					'domain' => "telecom.mvtel.local",
					'password' => "155"]);
	$user->storage($storage);
	$user->save();
	$find = Subscriber::from_array(['username' => "155"]);
	$find->storage($storage);
	$find1 = $find->find()[0];
	$this->assertSame($user->number, $find1->number);


	$find1->storage($storage);
	$find1->remove();
	$find_after_delete = $find->find();
	$this->assertSame($find_after_delete, []);

    }

    public function testnUpdateSubscriber(): void
    {
	$storage = new Storage("private/dbtext");
	$user = Subscriber::from_array(['username' => "155",
					'domain' => "telecom.mvtel.local",
					'password' => "155"]);
	$user->storage($storage);
	$user->save();

	$find = Subscriber::from_array(['username' => "155"]);
	$find->storage($storage);
	$find1 = $find->find()[0];
	$this->assertSame($user->number, $find1->number);

	$find1->pass = "200";
	$find1->storage($storage);
	$find1->save();
	$find_after_update = $find1->find()[0];
	$this->assertSame($find_after_update->pass, "200");
	$find_after_update->storage($storage);
	$find_after_update->remove();

    }
}
